/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"


//==============================================================================
October1AudioProcessorEditor::October1AudioProcessorEditor (October1AudioProcessor& p)
    : AudioProcessorEditor (&p), processor (p)
{
    // Make sure that before the constructor has finished, you've set the
    // editor's size to whatever you need it to be.
    addAndMakeVisible(slider);
    addAndMakeVisible(label);
    addAndMakeVisible(cbox);

    slider.setRange(0.0, 1.0);
    slider.setValue(0.5);
    label.setText("Speed", dontSendNotification);
    label.attachToComponent(&slider, true);
    cbox.addItem ("Ascending", 1);
    cbox.addItem ("Descending", 2);
    cbox.setSelectedId(1);
    
    slider.addListener(this);
    cbox.addListener(this);

    setSize (400, 200);
}

October1AudioProcessorEditor::~October1AudioProcessorEditor()
{
}

//==============================================================================
void October1AudioProcessorEditor::paint (Graphics& g)
{
    g.fillAll (Colours::white);

//    g.setColour (Colours::black);
//    g.setFont (15.0f);
//    g.drawFittedText ("Hello World!", getLocalBounds(), Justification::centred, 1);
}

void October1AudioProcessorEditor::resized()
{
    slider.setBounds(70, 30,
                     getWidth() - 100, getHeight() - 60);
    cbox.setBounds(70, 130, 300, 40);
}

void October1AudioProcessorEditor::sliderValueChanged(Slider* slider)
{
        auto& params = processor.getParameters();
        for (auto p : params)
        {
            if (auto* param =
                dynamic_cast<AudioParameterFloat*> (p))
            {
                if (param->paramID == "speed")
                    param->setValueNotifyingHost
                    (slider->getValue());
            }
        }
}

void October1AudioProcessorEditor::comboBoxChanged (ComboBox* combox)
{
    auto& params = processor.getParameters();
    for (auto p : params)
    {
        if (auto* param =
            dynamic_cast<AudioParameterInt*> (p))
        {
            if (param->paramID == "pattern")
                param->setValueNotifyingHost
                (combox->getSelectedId()-1);
        }
    }
}


